LeetCode: Majority Element

1. 题目:求Majority Element

Given an array of size n, find the majority element. The majority element is the element that appears more than ⌊ n/2 ⌋ times.
You may assume that the array is non-empty and the majority element always exist in the array.

Example 1:
Input: [3,2,3]
Output: 3

Example 2:
Input: [2,2,1,1,1,2,2]
Output: 2

2. solution one: Brute Force

Time complexity : O(n^2), Space complexity : O(1)

public int majorityElementBruteForce(int[] nums) {
        int majorityCount = nums.length/2;

        for (int num : nums) {
            int count = 0;
            for (int elem : nums) {
                if (elem == num) {
                    count += 1;
                }
            }

            if (count > majorityCount) {
                return num;
            }
        }

        return -1;
    }

3. solution two: HashMap

Time complexity : O(n), Space complexity : O(n)

public int majorityElementHashMap(int[] nums) {
        Map counts = countNums(nums);

        Map.Entry majorityEntry = null;
        for (Map.Entry entry : counts.entrySet()) {
            if (majorityEntry == null || entry.getValue() > majorityEntry.getValue()) {
                majorityEntry = entry;
            }
        }

        return majorityEntry.getKey();
    }

private Map countNums(int[] nums) {
        Map counts = new HashMap();
        for (int num : nums) {
            if (!counts.containsKey(num)) {
                counts.put(num, 1);
            }
            else {
                counts.put(num, counts.get(num)+1);
            }
        }
        return counts;
    }

4. solution three: sort

Time complexity : O(nlgn), Space complexity : O(1) or (O(n)

public int majorityElementSort(int[] nums) {
        Arrays.sort(nums);
        return nums[nums.length/2];
    }

5. solution fore: Boyer-Moore Voting Algorithm

Time complexity : O(n), Space complexity : O(1)

    public int majorityElementVoting(int[] nums) {
        int count = 0;
        Integer candidate = null;
        for (int num : nums) {
            if (0 == count) {
                candidate = num;
            }
            count += (num == candidate) ? 1 : -1;
        }

        return candidate;
    }

6. solution five: Divide and Conquer

Time complexity : O(nlgn), Space complexity : O(lgn)

public int majorityElementDivide(int[] nums) {
        return majorityElementRec(nums, 0, nums.length-1);
    }

    private int countInRange(int[] nums, int num, int lo, int hi) {
        int count = 0;
        for (int i = lo; i <= hi; i++) {
            if (nums[i] == num) {
                count++;
            }
        }
        return count;
    }

    private int majorityElementRec(int[] nums, int lo, int hi) {
        // base case; the only element in an array of size 1 is the majority
        // element.
        if (lo == hi) {
            return nums[lo];
        }

        // recurse on left and right halves of this slice.
        int mid = (hi-lo)/2 + lo;
        int left = majorityElementRec(nums, lo, mid);
        int right = majorityElementRec(nums, mid+1, hi);

        // if the two halves agree on the majority element, return it.
        if (left == right) {
            return left;
        }

        // otherwise, count each element and return the "winner".
        int leftCount = countInRange(nums, left, lo, hi);
        int rightCount = countInRange(nums, right, lo, hi);

        return leftCount > rightCount ? left : right;
    }

作者 @没有故事的老大爷
中国一点都不能少

你可能感兴趣的:(LeetCode: Majority Element)